---
title: ':has()'
slug: 'Web/CSS/:has'
tags:
  - ':has'
  - CSS
  - Experimental
  - Pseudo-class
  - Reference
  - Selector
  - Selectors
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>:has()</code></strong> CSS <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents an element if any of the selectors passed as parameters (relative to the {{cssxref(":scope")}} of the given element) match at least one element.</span></p>

<pre class="brush: css no-line-numbers notranslate">/* Selects any &lt;a&gt;, as long as it has an &lt;img&gt; element directly inside it  */
/* Note that this is not supported in any browser yet */
let test = document.querySelector('a:has(&gt; img)');</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Description</h2>

<p>The <code>:has()</code> pseudo-class takes a relative selector list as an argument. In earlier revisions of the CSS Selectors Level 4 specification, <code>:has</code> had a limitation that it couldn't be used within stylesheets. Instead, it could only be used with functions like {{domxref("document.querySelector()")}}; this was due to performance concerns. <em>This limitation has been removed</em> because no browser implemented it that way. Instead, browsers currently only support the use of <code>:has()</code> within stylesheets.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Matching_&lt;a&gt;_elements_that_directly_contain_an_&lt;img&gt;">Matching &lt;a&gt; elements that directly contain an &lt;img&gt;</h3>

<p>The following selector matches only {{HTMLElement("a")}} elements that directly contain an {{HTMLElement("img")}} child:</p>

<pre class="notranslate">a:has(&gt; img)
</pre>

<h3 id="Matching_&lt;h1&gt;_elements_that_are_followed_by_a_&lt;p&gt;">Matching &lt;h1&gt; elements that are followed by a &lt;p&gt;</h3>

<p>The following selector matches {{HTMLElement("h1")}} elements only if they have a {{htmlelement("p")}} element directly following them:</p>

<pre class="notranslate">h1:has(+ p)</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS4 Selectors", "#relational", ":has()")}}</td>
   <td>{{Spec2("CSS4 Selectors")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.has")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Document_object_model/Locating_DOM_elements_using_selectors">Locating DOM elements using selectors</a></li>
 <li><code><a href="/en-US/docs/Web/CSS/:scope">:scope</a></code></li>
</ul>
